/*
 * OneWire.h
 *
 *  Created on: 23-08-2013
 *      Author: Wojtek
 */

#ifndef ONEWIRE_H_
#define ONEWIRE_H_

#include "GLOBAL.h"



#define ONE_WIRE_OUT  			PA1
#define ONE_WIRE_PIN  			PINA
#define ONE_WIRE_PORT  			PORTA
#define ONE_WIRE_DDR  			DDRA

#define ONE_WIRE_GET_IN()   	bit_is_set(ONE_WIRE_PIN,ONE_WIRE_OUT) //Sprawda czy jest stan wysoki na wejsciu
#define ONE_WIRE_OUTPUT_LOW()  	cbi(ONE_WIRE_PORT,ONE_WIRE_OUT)
#define ONE_WIRE_OUTPUT_HIGH() 	sbi(ONE_WIRE_PORT,ONE_WIRE_OUT)
#define ONE_WIRE_DIR_INPUT()   	cbi(ONE_WIRE_DDR,ONE_WIRE_OUT)
#define ONE_WIRE_DIR_OUTPUT()  	sbi(ONE_WIRE_DDR,ONE_WIRE_OUT)

class OneWire {
public:
	static uint8_t Reset();
	static void SendByte(uint8_t byte);
	static uint8_t ReadByte(void);

private:
	static uint8_t ReadBit(void);
	static void SendBit(uint8_t bit);
};

#endif /* ONEWIRE_H_ */
